﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;

namespace CapitalExpenditureRequests.Workflow1
{
    public sealed partial class Workflow1 : SequentialWorkflowActivity
    {
        public Workflow1()
        {
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties workflowProperties = new SPWorkflowActivationProperties();
        public Guid TaskId = Guid.NewGuid();
        public SPWorkflowTaskProperties TaskProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        bool taskComplete = false;
        private void WhileTaskNotComplete(object sender, ConditionalEventArgs e)
        {
            if (taskComplete)
                e.Result = false;   // similar to while(0)
            else
                e.Result = true;    // similar to while(1)
        }

        public SPWorkflowTaskProperties AfterProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();
        public SPWorkflowTaskProperties BeforeProperties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        private string status = "";
        private void onTaskChanged1_Invoked(object sender, ExternalDataEventArgs e)
        {
            status = AfterProperties.
                ExtendedProperties["ApprovalStatus"].ToString();
        }

        private void createTask1_MethodInvoking(object sender, EventArgs e)
        {
            TaskProperties.Title = onWorkflowActivated1.WorkflowProperties.Item.Title;
            TaskProperties.Description = onWorkflowActivated1.WorkflowProperties.
                Item["RequestDescription"].ToString();
            TaskProperties.AssignedTo = "philsdevdomain\\pwicklund";
            TaskProperties.TaskType = 0;
        }
        private void IsApproved(object sender, ConditionalEventArgs e)
        {
            if (status == "Approved")
                e.Result = true;
            else
                e.Result = false;
        }

        private void IsDeferred(object sender, ConditionalEventArgs e)
        {
            if (status == "Deferred")
                e.Result = true;
            else
                e.Result = false;
        }

        enum CustomStates
        {
            Approved = 0,
            Rejected,
            Deferred,
            Canceled
        };

        private void setCanceledState_MethodInvoking(object sender, EventArgs e)
        {
            ((SetState)sender).State = (Int32)SPWorkflowStatus.Max +
                (Int32)CustomStates.Canceled;
        }

        private void setApprovedState_MethodInvoking(object sender, EventArgs e)
        {
            ((SetState)sender).State = (Int32)SPWorkflowStatus.Max +
                (Int32)CustomStates.Approved;
        }

        private void setDeferredState_MethodInvoking(object sender, EventArgs e)
        {
            ((SetState)sender).State = (Int32)SPWorkflowStatus.Max +
                (Int32)CustomStates.Deferred;
        }

        private void setRejectedState_MethodInvoking(object sender, EventArgs e)
        {
            ((SetState)sender).State = (Int32)SPWorkflowStatus.Max +
                (Int32)CustomStates.Rejected;
        }
    }
}
