﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Activities;
using Microsoft.SharePoint;
using System.Workflow.Runtime;
using Microsoft.SharePoint.Workflow;

namespace PluggableWorkflowServices
{
    [ExternalDataExchange]
    public interface IHelloWorldService
    {
        event EventHandler<HelloWorldEventArgs> HelloWorkflow;
        void HelloHost(string message);
    }

    class HelloWorldService : Microsoft.SharePoint.Workflow.SPWorkflowExternalDataExchangeService,
        IHelloWorldService
    {
        public event EventHandler<HelloWorldEventArgs> HelloWorkflow;
        public void HelloHost(string message)
        {
            SPWeb web = this.CurrentWorkflow.ParentWeb;
            SPList list = web.Lists["Announcements"];
            SPListItem item = list.Items.Add();
            item["Title"] = message;
            item["Instance"] = WorkflowEnvironment.WorkflowInstanceId.ToString();
            item.Update();
        }

        public override void CallEventHandler(Type type, string eventName,
          object[] parameters, SPWorkflow workflow, string identity,
          System.Workflow.Runtime.IPendingWork handler, object item)
        {
            switch (eventName)
            {
                case "HelloWorkflow":
                    var args = new HelloWorldEventArgs(workflow.InstanceId);
                    args.Answer = parameters[0].ToString();
                    this.HelloWorkflow(null, args);
                    break;
            }
        }

        public override void CreateSubscription(MessageEventSubscription subscription)
        { throw new NotImplementedException(); }
        public override void DeleteSubscription(Guid subscriptionId)
        { throw new NotImplementedException(); }
    }

    [Serializable]
    public class HelloWorldEventArgs : ExternalDataEventArgs
    {
        public HelloWorldEventArgs(Guid id) : base(id) { }
        public string Answer;
    }
}
