﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;
using System.Xml.Serialization;
using System.Xml;
using System.IO;

namespace SiteCollectionSupportWorkflow.Workflow1
{
    public sealed partial class Workflow1 : SequentialWorkflowActivity
    {
        string tier1;
        string tier2;
        string tier3;
        string currentTier;

        public Workflow1()
        {
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties workflowProperties = new SPWorkflowActivationProperties();

        private void WhileRequestIsNotComplete(object sender, ConditionalEventArgs e)
        {
            string status = onWorkflowActivated1.WorkflowProperties.
                Item["Status"].ToString();

            if (status == "Resolved")
                e.Result = false;
            else
                e.Result = true;
        }

        private void onWorkflowActivated1_Invoked(object sender, ExternalDataEventArgs e)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(SupportGroups));

            XmlTextReader reader = new XmlTextReader(new System.IO.StringReader(
                onWorkflowActivated1.WorkflowProperties.AssociationData));

            SupportGroups associationFormData = (SupportGroups)serializer.Deserialize(reader);

            tier1 = associationFormData.Tier1Group;
            tier2 = associationFormData.Tier2Group;
            tier3 = associationFormData.Tier3Group;
            currentTier = tier1;
        }

        public static DependencyProperty enableWorkflowModification1_ContextData1Property = DependencyProperty.Register("enableWorkflowModification1_ContextData1", typeof(System.String), typeof(SiteCollectionSupportWorkflow.Workflow1.Workflow1));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public String enableWorkflowModification1_ContextData1
        {
            get
            {
                return ((string)(base.GetValue(SiteCollectionSupportWorkflow.Workflow1.Workflow1.enableWorkflowModification1_ContextData1Property)));
            }
            set
            {
                base.SetValue(SiteCollectionSupportWorkflow.Workflow1.Workflow1.enableWorkflowModification1_ContextData1Property, value);
            }
        }

        public String onWorkflowModified1_User1 = default(System.String);

        private void enableWorkflowModification1_MethodInvoking(object sender, EventArgs e)
        {
            TicketModificationFields data = new TicketModificationFields();
            data.CurrentOwnerGroup = currentTier;
            data.NextTierGroup = tier2;

            using (StringWriter writer = new StringWriter())
            {
                XmlSerializer s = new XmlSerializer(typeof(TicketModificationFields));
                s.Serialize(writer, data);
                this.enableWorkflowModification1_ContextData1 = writer.ToString();
            }
        }
    }
}
